////////////////////////////////////////////////////////////////////////////
// $Id: Deint_Bob.h,v 1.4 2004/02/06 12:17:15 adcockj Exp $
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2003 John Adcock.  All rights reserved.
// This software was based on sample code generated by the 
// DMO project wizard.  That code is (c) Microsoft Corporation
/////////////////////////////////////////////////////////////////////////////
//
// This file is free software; you can redistribute it and/or modify it
// under the terms of the GNU Library General Public License as published by
// the Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// This software is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details
//
/////////////////////////////////////////////////////////////////////////////
// CVS Log
//
// $Log: Deint_Bob.h,v $
// Revision 1.4  2004/02/06 12:17:15  adcockj
// Major changes to the Libraries to remove ATL and replace with YACL
// First draft of Mpeg2 video decoder filter
// Broken DScalerFilter part converted to new library
//
// Revision 1.3  2003/10/31 17:19:37  adcockj
// Added support for manual pulldown selection (works with Elecard Filters)
//
// Revision 1.2  2003/05/20 16:50:58  adcockj
// Interim checkin, preparation for DMO processing path
//
// Revision 1.1  2003/05/16 16:19:12  adcockj
// Added new files into DMO framework
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include "..\..\DMO_Lib\DMO_Lib.h"
#include "..\..\DMO_Lib\CDeintDMO.h"
#include "resource.h"


DEFINE_GUID(CLSID_CDeint_Bob, 0x13F75833,0x8615,0x11d7,0xB8,0x4E,0x00,0x02,0xA5,0x62,0x33,0x77);


class CDeint_Bob : 
	public CDeintDMO,
    public IAmFreeSoftwareLicensed
{
public:
IMPLEMENT_AGGREGATABLE_COCLASS(CDeint_Bob, "{13F75833-8615-11d7-B84E-0002A5623377}", "Deint_Bob Class", "DMO.Deint_Bob.1", "DMO.Deint_Bob", "both")
	IMPLEMENTS_INTERFACE(IAmFreeSoftwareLicensed)
    IMPLEMENTS_INTERFACE(IMediaObject)
    IMPLEMENTS_INTERFACE(IMediaParams)
    IMPLEMENTS_INTERFACE(IMediaParamInfo)
    IMPLEMENTS_INTERFACE(IPersistStream)
    IMPLEMENTS_INTERFACE(ISpecifyPropertyPages)
    IMPLEMENTS_INTERFACE(IDScalerVideoFilterPlugin)
    IMPLEMENTS_INTERFACE(IInterlacedBufferStack)
    IMPLEMENTS_INTERFACE(IDeinterlace)
    IMPLEMENTS_INTERFACE(IDScalerFilterPlugin)
END_INTERFACE_TABLE()

public:
    CDeint_Bob();	// Constructor
    ~CDeint_Bob();	// Destructor

BEGIN_PARAM_LIST()
END_PARAM_LIST()

public:
    STDMETHODIMP STDMETHODCALLTYPE GetClassID(CLSID *pClsid);

// IAmFreeSoftwareLicensed
public:
	STDMETHOD(get_Name)(BSTR* Name);
	STDMETHOD(get_License)(eFreeLicense* License);
	STDMETHOD(get_Authors)(BSTR* Authors);

// IDeinterlace
public:
    STDMETHOD(Process)(IInterlacedBufferStack* Stack, IMediaBuffer* pOutBuffer);

private:
    HRESULT ParamChanged(DWORD dwParamIndex);
};

